
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <io.h>
#include <conio.h>
#include <dir.h>
#include <dirent.h>
#include "msg.h"

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

struct _CNMHDR cnmhdr;
struct _CNMMHDR cnmmhdr;
struct _CNMTDX cnmtdx;
struct _CFG cfg;

void getcfg(void);


void main()
{
   char fnme[65],xnme[65],*p;
   FILE *tfd,*xfd;
   struct find_t fb;
   int copying=FALSE;
   long ctme,nsize,age,writepos,readpos;
   unsigned char *mbuf;
   int skip,done,scoop,lastread,crecord=0;

   getcfg();
   time(&ctme);
   _setcursortype(_NOCURSOR);
   printf("\nCNPack v1.01 - (c)1993 Simon Ewins - "__DATE__" @ "__TIME__"\n");
   sprintf(fnme,"%s*.Msg",".\\MAIL\\");
   done=_dos_findfirst(fnme,_A_NORMAL,&fb);
   while(!done) {
      sprintf(fnme,"%s%s",".\\MAIL\\",fb.name);
      tfd=fopen(fnme,"r+b");
      strcpy(xnme,fnme);
      p=strrchr(xnme,'.')+1;
      strcpy(p,"To");
      xfd=fopen(xnme,"r+b");
      if(!xfd) {
         fclose(tfd);
         printf("Error: Can't open %s\n",xnme);
      } else {
         if(tfd) {
            printf("\nPacking %12s:",fb.name);
            crecord=0;
            copying=FALSE;
            nsize=filelength(fileno(tfd));

            /*-----------------11-06-93 01:29pm---------------------
             Get the values for maximum and oldest messages allowed.
             ------------------------------------------------------*/
            fread(&cnmhdr,sizeof(cnmhdr),1,tfd);
            lastread=cnmhdr.lastread;
            skip=cnmhdr.messages-cnmhdr.maximum;
            age=ctme-(cnmhdr.days*86400L);
            if(skip>0) {
               lastread-=skip;
               nsize=writepos=ftell(tfd);
               copying=TRUE;
            } else {
               skip=0;
            }

            /*-----------------11-06-93 01:30pm-----------------------
             Move to first message (in the index) that we are keeping.
             --------------------------------------------------------*/
            if(!fseek(xfd,(long)(skip*sizeof(cnmtdx)),SEEK_SET)) {
               fread(&cnmtdx,sizeof(cnmtdx),1,xfd);
               while(!feof(xfd)) {
                  fseek(tfd,cnmtdx.offset,SEEK_SET);
                  fread(&cnmmhdr,sizeof(cnmmhdr),1,tfd);
                  if(cnmmhdr.adate<age) {
                     cnmmhdr.deleted=TRUE;
                     if(!copying) {
                        nsize=writepos=cnmtdx.offset;
                        copying=TRUE;
                     }
                  }
                  if(!cnmmhdr.deleted) {
                     /*-----------------11-07-93 11:50pm-----------------
                      Need to keep this message since it isn't deleted.
                      --------------------------------------------------*/
                     if(copying) {
                        /*-----------------11-07-93 11:50pm-------------------
                         Need to move the message up since previous message(s)
                         have been deleted and skipped.
                         ----------------------------------------------------*/
                        readpos=cnmtdx.offset;
                        fread(&cnmtdx,sizeof(cnmtdx),1,xfd);
                        /*-----------------11-07-93 11:51pm-----------------
                         Get the number of bytes that need to be moved.
                         --------------------------------------------------*/
                        if(!feof(xfd)) {
                           scoop=(int)(cnmtdx.offset-readpos);
                           fseek(xfd,-(long)(sizeof(cnmtdx)),SEEK_CUR);
                        } else {
                           fseek(tfd,readpos,SEEK_SET);
                           fread(&cnmmhdr,sizeof(cnmmhdr),1,tfd);
                           scoop=(long)(sizeof(cnmmhdr)+cnmmhdr.control+cnmmhdr.length+cnmmhdr.trailer+sizeof(long));
                        }
                        /*-----------------11-07-93 11:52pm-----------------
                         Grab some memory and read the bytes that need to be
                         moved into it.
                         --------------------------------------------------*/
                        mbuf=(unsigned char *)malloc(scoop);
                        fseek(tfd,readpos,SEEK_SET);
                        fread(mbuf,scoop,1,tfd);
                        /*-----------------11-07-93 11:52pm-----------------
                         Move to the currrent write position and write all
                         but the last 4 bytes scooped.
                         --------------------------------------------------*/
                        fseek(tfd,writepos,SEEK_SET);
                        fwrite(mbuf,scoop-sizeof(long),1,tfd); /* avoid old start */
                        /*-----------------11-07-93 11:53pm-----------------
                         Then write a new 'start-of-message' pointer using
                         the writepos variable that got us here. Free up the
                         memory we allocated for the scoop.
                         --------------------------------------------------*/
                        fwrite(&writepos,sizeof(long),1,tfd);  /* new start position */
                        free(mbuf);
                        /*-----------------11-07-93 11:54pm-----------------
                         Bump the writepos to point to the end of the just
                         written message and set the new file size to the
                         same position.
                         --------------------------------------------------*/
                        writepos+=scoop;
                        nsize=writepos;
                     }
                  } else {
                     if(!copying) {
                        nsize=writepos=cnmtdx.offset;
                        copying=TRUE;
                     }
                     if(lastread>=crecord) lastread--;
                     crecord--;
                  }
                  crecord++;
                  printf("\rPacking %12s: %5d",fb.name,crecord);
                  fread(&cnmtdx,sizeof(cnmtdx),1,xfd);
               }
               printf("\nReIndex %12s:",fb.name);

               /*-----------------11-07-93 11:55pm-----------------
                Change the file size as appropriate and close the
                file to guarantee that the change takes place. We
                then reopen the data file and reindex it.
                --------------------------------------------------*/
               chsize(fileno(tfd),nsize);
               fclose(tfd);
               tfd=fopen(fnme,"r+b");
               chsize(fileno(xfd),0L);
               fclose(xfd);
               xfd=fopen(xnme,"r+b");
               cnmhdr.messages=crecord;
               cnmhdr.lastread=lastread>0?lastread:0;
               time(&cnmhdr.update);
               fwrite(&cnmhdr,sizeof(cnmhdr),1,tfd);
               fseek(tfd,0L,SEEK_CUR);
               memset(&cnmtdx,0,sizeof(cnmtdx));
               cnmtdx.offset=ftell(tfd);
               fread(&cnmmhdr,sizeof(cnmmhdr),1,tfd);
               while(!feof(tfd)) {
                  crecord--;
                  printf("\rReIndex %12s: %5d",fb.name,crecord);
                  strcpy(cnmtdx.to,cnmmhdr.to);
                  fwrite(&cnmtdx,sizeof(cnmtdx),1,xfd);
                  fseek(tfd,(long)(cnmmhdr.control+cnmmhdr.length+cnmmhdr.trailer+sizeof(long)),SEEK_CUR);
                  memset(&cnmtdx,0,sizeof(cnmtdx));
                  cnmtdx.offset=ftell(tfd);
                  fread(&cnmmhdr,sizeof(cnmmhdr),1,tfd);
               }
            }
            fclose(tfd);
            fclose(xfd);
         } else {
            fclose(xfd);
         }
      }
      done=_dos_findnext(&fb);
   }
   putchar('\n');
   _setcursortype(_NORMALCURSOR);
}


void getcfg()
{
   static char *errmsg=" subdirectory not found\n";
   FILE *fd;
   DIR *d;

   fd=fopen("CNMsg.Cfg","rb");
   if(!fd) {
      printf("\nUnable to open CNMsg.Cfg\n");
      exit(1);
   }
   fread(&cfg,sizeof(cfg),1,fd);
   fclose(fd);
   d=opendir(".\\MAIL");
   if(!d) {
      printf("\nMAIL%s",errmsg);
      exit(1);
   }
   closedir(d);
   d=opendir(".\\SEND");
   if(!d) {
      printf("\nSEND%s",errmsg);
      exit(1);
   }
   closedir(d);
   d=opendir(".\\RCV");
   if(!d) {
      printf("\nRCV%s",errmsg);
      exit(1);
   }
   closedir(d);
   d=opendir(".\\WORK");
   if(!d) {
      printf("\nWORK%s",errmsg);
      exit(1);
   }
   closedir(d);
}


